import { useEffect, useRef } from "react";
import { gsap } from "gsap";

export const PandaCEA = ({ isEyesClose, svgWidth, svgHeight }) => {
  const armRRef = useRef(null);
  const armLRef = useRef(null);

  useEffect(() => {
    if (isEyesClose === true) {
      coverEyes();
    } else {
      unCoverEyes();
    }
  }, [isEyesClose]);

  const coverEyes = () => {
    gsap.killTweensOf([armLRef.current, armRRef.current]);
    gsap.set([armLRef.current, armRRef.current], { visibility: "visible" });
    gsap.to(armLRef.current, {
      duration: 0.45,
      x: -10,
      y: 150,
      rotation: 0,
      ease: "power1.out"
    });
    gsap.to(armRRef.current, {
      duration: 0.45,
      x: 260,
      y: 150,
      rotation: 0,
      ease: "power1.out"
    });
  };

  const unCoverEyes = () => {
    gsap.killTweensOf([armLRef.current, armRRef.current]);
    gsap.set([armLRef.current, armRRef.current], { visibility: "visible" });
    gsap.to(armLRef.current, {
      duration: 0.45,
      x: 50,
      y: 390,
      rotation: 60,
      ease: "power1.out"
    });
    gsap.to(armRRef.current, {
      duration: 0.45,
      x: 270,
      y: 555,
      rotation: -60,
      ease: "power1.out",
      onComplete: function () {
        gsap.set([armLRef.current, armRRef.current], { visibility: "hidden" });
      }
    });
  };

  return (
    <>
      <svg
        width={svgWidth}
        height={svgHeight}
        viewBox="0 0 500 450"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
      >
        {/* left ear */}
        <circle cx="81.5" cy="114.5" r="59.5" fill="black" />
        {/* right ear */}
        <circle cx="411.5" cy="114.5" r="59.5" fill="black" />
        {/* face */}
        <path
          d="M461 286.5C461 332.741 436.021 369.654 396.667 395.432C357.14 421.323 303.635 435.5 249 435.5C194.355 435.5 139.544 421.316 98.7194 395.358C58.0239 369.483 32 332.549 32 286.5C32 151.572 141.568 65 249 65C356.297 65 461 146.443 461 286.5Z"
          fill="white"
          stroke="black"
          strokeWidth="20"
        />
        {/* left eye patch */}
        <path
          d="M219.131 215.038C219.131 242.547 180.975 299.31 127.954 294.024C125.41 293.77 122.825 293.637 120.299 293.243C97.2823 289.654 84.9073 253.982 91.9906 224.642C93.5573 218.153 94.7432 211.474 96.6202 205.068C103.831 180.456 135.795 158.038 160.631 158.038C181.631 158.038 219.131 154.538 219.131 215.038Z"
          fill="black"
        />
        {/* right eye patch*/}
        <path
          d="M345.364 294.313C317.903 292.634 262.79 245.099 271.278 192.215C271.683 189.691 271.976 187.125 272.525 184.628C277.614 161.476 315.295 147.598 344.423 155.721C350.853 157.515 357.481 159.103 363.67 161.605C387.468 171.227 406.528 208.351 405.012 233.136C403.73 254.097 405.751 298.007 345.364 294.313Z"
          fill="black"
        />
        {/* left eye */}
        <ellipse cx="160.5" cy="208" rx="19.5" ry="28" fill="white" />
        {/* right eye */}
        <ellipse cx="332.5" cy="208" rx="19.5" ry="28" fill="white" />
        {/* nose */}
        <path
          d="M287 277.5C287 289.374 268.868 314.5 246.5 314.5C224.132 314.5 206 289.374 206 277.5C206 265.626 224.132 256 246.5 256C268.868 256 287 265.626 287 277.5Z"
          fill="black"
        />
        {/* smile left part */}
        <path
          d="M165.863 331.644C160.42 330.711 155.25 334.367 154.317 339.81C153.384 345.254 157.04 350.423 162.484 351.356L165.863 331.644ZM248.156 335.719C251.75 331.526 251.265 325.213 247.072 321.619C242.878 318.025 236.565 318.51 232.971 322.703L248.156 335.719ZM247.173 311.344L257.173 311.344L247.173 311.344ZM235.134 334.062L229.519 325.788L235.134 334.062ZM240.564 329.211L232.971 322.703L240.564 329.211ZM214.684 343.777L212.351 334.053L214.684 343.777ZM232.248 336.021L226.633 327.746L232.248 336.021ZM187.022 345.417L185.332 355.273L187.022 345.417ZM162.484 351.356L185.332 355.273L188.711 335.561L165.863 331.644L162.484 351.356ZM213.496 354.347L217.018 353.501L212.351 334.053L208.828 334.899L213.496 354.347ZM237.863 344.295L240.749 342.337L229.519 325.788L226.633 327.746L237.863 344.295ZM257.173 311.344L257.173 298L237.173 298L237.173 311.344L257.173 311.344ZM248.156 335.719C253.975 328.931 257.173 320.285 257.173 311.344L237.173 311.344C237.173 315.51 235.683 319.54 232.971 322.703L248.156 335.719ZM240.749 342.337C243.501 340.47 245.992 338.244 248.156 335.719L232.971 322.703C231.962 323.88 230.802 324.917 229.519 325.788L240.749 342.337ZM217.018 353.501C224.465 351.714 231.527 348.595 237.863 344.295L226.633 327.746C222.291 330.692 217.453 332.829 212.351 334.053L217.018 353.501ZM185.332 355.273C194.686 356.877 204.268 356.561 213.496 354.347L208.828 334.899C202.237 336.481 195.393 336.706 188.711 335.561L185.332 355.273Z"
          fill="black"
        />
        {/* smile right part */}
        <path
          d="M329.127 330.992C334.538 329.882 339.823 333.369 340.932 338.779C342.042 344.189 338.555 349.475 333.145 350.584L329.27 330.992ZM247.006 337.735C243.278 333.66 243.559 327.335 247.634 323.607C251.709 319.879 258.034 320.16 261.762 324.234L247.006 337.735ZM259.968 335.658L265.312 327.205L259.968 335.658ZM254.384 330.985L261.762 324.234L254.384 330.985ZM284.27 345.435L282.253 355.23L284.27 345.435ZM333.145 350.584L310.434 355.241L306.417 335.649L329.127 330.992L333.145 350.584ZM282.253 355.23L278.706 354.499L282.74 334.91L286.287 335.641L282.253 355.23ZM257.572 345.974L254.624 344.11L265.312 327.205L268.26 329.069L257.572 345.974ZM237.205 313.663L236.773 300.324L256.763 299.676L257.194 313.016L237.205 313.663ZM247.006 337.735C240.971 331.138 237.494 322.6 237.205 313.663L257.194 313.016C257.329 317.181 258.949 321.16 261.762 324.234L247.006 337.735ZM254.624 344.11C251.813 342.333 249.251 340.189 247.006 337.735L261.762 324.234C262.808 325.378 264.002 326.377 265.312 327.205L254.624 344.11ZM278.706 354.499C271.205 352.955 264.045 350.066 257.572 345.974L268.26 329.069C272.695 331.873 277.6 333.852 282.74 334.91L278.706 354.499ZM310.434 355.241C301.137 357.148 291.549 357.144 282.253 355.23L286.287 335.641C292.927 337.008 299.776 337.011 306.417 335.649L310.434 355.241Z"
          fill="black"
        />
        <g className="arms" clipPath="url(#armMask)">
          {/* Left Hand */}
          <g
            ref={armLRef}
            transform="translate(50,225) rotate(45)"
            clipPath="url(#clip0_11_8) "
            style={{ visibility: "hidden" }}
          >
            <rect
              x="-2.12132"
              width="113"
              height="272.008"
              rx="56.5"
              transform="matrix(-0.707107 -0.707107 -0.707107 0.707107 259.863 67.5244)"
              fill="black"
              stroke="#525252"
              strokeWidth="3"
            />
            <path
              d="M238.801 58.9274L229.311 63.1034C228.322 63.5383 227.441 62.3145 228.168 61.5154L234.804 54.2155C234.932 54.0747 235.097 53.9734 235.281 53.9234L242.741 51.8887C243.702 51.6267 244.414 52.7767 243.75 53.5195L239.145 58.6781C239.049 58.7848 238.932 58.8698 238.801 58.9274Z"
              fill="white"
              stroke="#525252"
            />
            <path
              d="M189.383 14.5204L181.296 21.0105C180.454 21.6865 179.287 20.7323 179.781 19.7724L184.302 11.0036C184.389 10.8346 184.523 10.6939 184.687 10.5981L191.367 6.70181C192.227 6.20009 193.212 7.12673 192.764 8.01587L189.65 14.1908C189.585 14.3185 189.494 14.4309 189.383 14.5204Z"
              fill="white"
              stroke="#525252"
            />
            <path
              d="M207.968 19.057L199.347 24.8176C198.449 25.4176 197.369 24.3653 197.946 23.4522L203.214 15.1108C203.315 14.95 203.46 14.8215 203.632 14.7403L210.626 11.4411C211.527 11.0162 212.427 12.0252 211.903 12.8718L208.263 18.7519C208.188 18.8735 208.087 18.9775 207.968 19.057Z"
              fill="white"
              stroke="#525252"
            />
            <path
              d="M221.44 29.5246L212.349 34.5119C211.402 35.0313 210.418 33.8889 211.072 33.0295L217.047 25.179C217.162 25.0277 217.318 24.9123 217.497 24.8465L224.751 22.1693C225.686 21.8246 226.495 22.9082 225.899 23.706L221.76 29.2464C221.674 29.361 221.565 29.4559 221.44 29.5246Z"
              fill="white"
              stroke="#525252"
            />
            <path
              d="M232.801 42.9274L223.311 47.1034C222.322 47.5383 221.441 46.3145 222.168 45.5154L228.804 38.2155C228.932 38.0747 229.097 37.9734 229.281 37.9234L236.741 35.8887C237.702 35.6267 238.414 36.7767 237.75 37.5195L233.145 42.6781C233.049 42.7848 232.932 42.8698 232.801 42.9274Z"
              fill="white"
              stroke="#525252"
            />
          </g>
          {/* Right Hand */}
          <g
            ref={armRRef}
            transform="translate(270,400) rotate(-45)"
            clipPath="url(#clip0_7_2)"
            style={{ visibility: "hidden" }}
          >
            <rect
              x="-10.8787"
              y="69.0244"
              width="113"
              height="272.008"
              rx="56.5"
              transform="rotate(-45 -10.8787 69.0244)"
              fill="black"
              stroke="#525252"
              strokeWidth="3"
            />
            <path
              d="M13.1987 60.9274L22.6895 65.1034C23.678 65.5383 24.5586 64.3145 23.8322 63.5154L17.1959 56.2155C17.068 56.0747 16.9025 55.9734 16.7191 55.9234L9.2586 53.8887C8.2979 53.6267 7.58633 54.7767 8.24954 55.5195L12.8555 60.6781C12.9507 60.7848 13.0677 60.8698 13.1987 60.9274Z"
              fill="white"
              stroke="#525252"
            />
            <path
              d="M57.5251 11.5204L65.6117 18.0105C66.4539 18.6865 67.6213 17.7323 67.1264 16.7724L62.6056 8.00361C62.5185 7.83457 62.3849 7.69389 62.2207 7.59807L55.541 3.70181C54.6809 3.20009 53.6959 4.12673 54.1443 5.01587L57.2581 11.1908C57.3225 11.3185 57.4135 11.4309 57.5251 11.5204Z"
              fill="white"
              stroke="#525252"
            />
            <path
              d="M41.1438 17.057L49.7653 22.8176C50.6632 23.4176 51.743 22.3653 51.1664 21.4522L45.8985 13.1108C45.797 12.95 45.6517 12.8215 45.4796 12.7403L38.4858 9.44106C37.5852 9.0162 36.6848 10.0252 37.2089 10.8718L40.8491 16.7519C40.9244 16.8735 41.0249 16.9775 41.1438 17.057Z"
              fill="white"
              stroke="#525252"
            />
            <path
              d="M27.7005 29.5246L36.7913 34.5119C37.7381 35.0313 38.722 33.8889 38.068 33.0295L32.0932 25.179C31.978 25.0277 31.8221 24.9123 31.6437 24.8465L24.3889 22.1693C23.4547 21.8246 22.6456 22.9082 23.2416 23.706L27.3804 29.2464C27.4659 29.361 27.5751 29.4559 27.7005 29.5246Z"
              fill="white"
              stroke="#525252"
            />
            <path
              d="M19.1987 42.9274L28.6895 47.1034C29.678 47.5383 30.5586 46.3145 29.8322 45.5154L23.1959 38.2155C23.068 38.0747 22.9025 37.9734 22.7191 37.9234L15.2586 35.8887C14.2979 35.6267 13.5863 36.7767 14.2495 37.5195L18.8555 42.6781C18.9507 42.7848 19.0677 42.8698 19.1987 42.9274Z"
              fill="white"
              stroke="#525252"
            />
          </g>
        </g>
      </svg>
    </>
  );
};
